<template>
  <div>
    <h2 id="page-heading" data-cy="PreguntaHeading">
      <span v-text="$t('gatewayApp.pacientesPregunta.home.title')" id="pregunta-heading">Preguntas</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesPregunta.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'PreguntaCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-pregunta"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesPregunta.home.createLabel')"> Create a new Pregunta </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && preguntas && preguntas.length === 0">
      <span v-text="$t('gatewayApp.pacientesPregunta.home.notFound')">No preguntas found</span>
    </div>
    <div class="table-responsive" v-if="preguntas && preguntas.length > 0">
      <table class="table table-striped" aria-describedby="preguntas">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('pregunta')">
              <span v-text="$t('gatewayApp.pacientesPregunta.pregunta')">Pregunta</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'pregunta'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('condicion.condicion')">
              <span v-text="$t('gatewayApp.pacientesPregunta.condicion')">Condicion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'condicion.condicion'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="pregunta in preguntas" :key="pregunta.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'PreguntaView', params: { preguntaId: pregunta.id } }">{{ pregunta.id }}</router-link>
            </td>
            <td>{{ pregunta.pregunta }}</td>
            <td>
              <div v-if="pregunta.condicion">
                <router-link :to="{ name: 'CondicionView', params: { condicionId: pregunta.condicion.id } }">{{
                  pregunta.condicion.condicion
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link :to="{ name: 'PreguntaView', params: { preguntaId: pregunta.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link :to="{ name: 'PreguntaEdit', params: { preguntaId: pregunta.id } }" custom v-slot="{ navigate }">
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(pregunta)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span id="gatewayApp.pacientesPregunta.delete.question" data-cy="preguntaDeleteDialogHeading" v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p id="jhi-delete-pregunta-heading" v-text="$t('gatewayApp.pacientesPregunta.delete.question', { id: removeId })">
          Are you sure you want to delete this Pregunta?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-pregunta"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removePregunta()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./pregunta.component.ts"></script>
